using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;

namespace GridGroup3
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(80, 160);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(648, 352);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "3.201.1.0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(752, 622);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		//hashtable declaration.
		Hashtable checkboxvalues=new Hashtable();
		Hashtable childcheckboxvalues = new Hashtable();

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataSet dSet = new DataSet();

			parentTable = GetParentTable();
			childTable = GetChildTable();			
			dSet.Tables.AddRange(new DataTable[]{parentTable, childTable});

			//setup the relations
			DataColumn parentColumn = parentTable.Columns["parentID"];
			DataColumn childColumn = childTable.Columns["ParentID"];

			dSet.Relations.Add("ParentToChild", parentColumn, childColumn);	
			this.gridGroupingControl1.DataSource = parentTable;		

			this.gridGroupingControl1.TableDescriptor.UnboundFields.Add("print");
			gridGroupingControl1.TableDescriptor.Columns["print"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";


			this.gridGroupingControl1.TableDescriptor.Relations["ParentToChild"].ChildTableDescriptor.UnboundFields.Add("ChildCheckBox");
			gridGroupingControl1.TableDescriptor.Relations["ParentToChild"].ChildTableDescriptor.Columns["ChildCheckBox"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";

			this.gridGroupingControl1.TableDescriptor.QueryValue += new FieldValueEventHandler(unboundField_QueryValue); // Routine that queries for the value
			this.gridGroupingControl1.TableDescriptor.SaveValue += new FieldValueEventHandler(unboundField_SaveValue); // Routine that queries for the value

			this.gridGroupingControl1.TableDescriptor.Relations["ParentToChild"].ChildTableDescriptor.QueryValue += new FieldValueEventHandler(ChildTableDescriptor_QueryValue);
			this.gridGroupingControl1.TableDescriptor.Relations["ParentToChild"].ChildTableDescriptor.SaveValue += new FieldValueEventHandler(ChildTableDescriptor_SaveValue);
		}

		# region DataTable  
		DataTable parentTable, childTable;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");
			dt.Columns.Add("ParentID",typeof(int));
			dt.Columns.Add("Integer",typeof(int));
			DataRow dr ;
			for (int i = 0 ; i < 10 ; i++ )
			{
				dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = i + 5;
				dt.Rows.Add(dr);
			}
			dt.EndLoadData();
			dt.PrimaryKey=new DataColumn[]{dt.Columns["ParentID"]};
			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");
			dt.Columns.Add("ParentID",typeof(int));
			dt.Columns.Add("Integer1",typeof(int));
			DataRow dr ;
			for (int i = 0 ; i < 20 ; i++ )
			{
				dr = dt.NewRow();
				dr[0] = (i % 10).ToString(); 
				dr[1] = i + 2;
				dt.Rows.Add(dr);
			}		
			dt.EndLoadData();
			dt.PrimaryKey=new DataColumn[]{dt.Columns["Integer1"]};
			return dt;
		}
		# endregion

		//Getting the checkBox values in a hashtable.
		private void unboundField_QueryValue(object sender, FieldValueEventArgs e)
		{
			int RecordIndex =this.gridGroupingControl1.Table.PrimaryKeySortedRecords.IndexOf(e.Record);	
			if (e.Field.Name == "print" && RecordIndex>=0)
			{
				object value = checkboxvalues[RecordIndex];
				if (value != null)
					e.Value= value;
			}
		}
		
		private void unboundField_SaveValue(object sender, FieldValueEventArgs e)
		{
			int RecordIndex =this.gridGroupingControl1.Table.PrimaryKeySortedRecords.IndexOf(e.Record);
			if (e.Field.Name == "print" && RecordIndex>=0)
			{
				checkboxvalues[RecordIndex] = e.Value;
			}
		}

		private void ChildTableDescriptor_QueryValue(object sender, FieldValueEventArgs e)
		{
			int RecordIndex =this.gridGroupingControl1.Table.RelatedTables["ParentToChild"].PrimaryKeySortedRecords.IndexOf(e.Record);		
			if (e.Field.Name == "ChildCheckBox" && RecordIndex>=0)
			{
				object value = childcheckboxvalues[RecordIndex];				
				if (value != null)
					e.Value= value;
			}
		}

		private void ChildTableDescriptor_SaveValue(object sender, FieldValueEventArgs e)
		{
			int RecordIndex =this.gridGroupingControl1.Table.RelatedTables[0].PrimaryKeySortedRecords.IndexOf(e.Record);					
			if (e.Field.Name == "ChildCheckBox" && RecordIndex>=0)
			{
				childcheckboxvalues[RecordIndex] = e.Value;				
			}
		}
	}
}
